unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils,
  System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  Vcl.ExtCtrls, Vcl.Buttons,
  math, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Shape1: TShape;
    Timer1: TTimer;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Panel2: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Label5: TLabel;
    Edit1: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    Edit2: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    CheckBox1: TCheckBox;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
  private
    { Private declarations }
     y,piso      : integer;
     y0,v0,g     : single;
     yy,vv,t,dt  : single;
     ymax,tc     : single;

     x0,xx,v0x   : single;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  piso  := Panel1.top;

  SpeedButton3.Click;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  Timer1.Enabled := true;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  Timer1.Enabled := false;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
var
  DD  : single;
begin
  Timer1.Enabled := false;

  y0    := 200;
  Shape1.Top := ceil(y0);

  x0    := 80;
  Shape1.Left := ceil(x0);

  v0    := 10.0;

  g     := 10;
  t     := 0;
  tc    := 0;

  DD  := StrToInt(Edit1.Text);
  if (DD<10) or (dd>100) then begin
    ShowMessage ('dt fuera de rango usando default: 50' );
    DD := 50;
  end;

  Timer1.Interval := ceil(DD);

  dt    := DD/1000;
  ymax  := 0;

  v0x := StrToFloat(Edit2.Text);

end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  t  := t  + dt;
  tc := tc + dt;

  // movimiento vertical
  vv :=  v0 - g*t;
  yy :=  10*( y0/10 +  v0*t - g*t*t/2) ;
  ymax := MAX(ymax,yy);

  Shape1.Top := ceil(piso - yy);

  if ( (yy-20)<= 0) then begin   // condicion de choque/base
    Label4.Caption := 'ymax = ' + Format('%9.4f', [ymax]);
    v0 :=  sqrt(2*g*(ymax-20)/10);
    y0 := 20;
    t := 0;
  end;

  // movimiento horizontal
  xx := v0x*tc;

  Shape1.Left := ceil(x0 + 10*xx);

  if ((Shape1.Left+20) >= ClientWidth  ) then begin
    x0 := 2;
    tc := 0;
  end;

  // reporte
  if CheckBox1.Checked then begin
    Label1.Caption := 'yy = ' + IntToStr( ceil(yy));
    Label2.Caption := 'vv = ' + IntToStr( ceil(vv));
    Label3.Caption := 'tt = ' + Format('%9.4f', [t]);
    Label9.Caption := 'x = ' + Format('%9.4f', [x0/10 + xx]);
  end;

end;

end.
